<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: data/Collection.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: data/Collection.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * @license
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2014 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

define(['backbone', 'underscore', 'uweaver/lang',
    'uweaver/data/proxy/Proxy', 'uweaver/data/proxy/REST', 'uweaver/data/reader/Reader', 'uweaver/data/reader/Json',
    'uweaver/data/Model', 'uweaver/number'], function(Backbone, _, lang, Proxy, REST, Reader, Json, Model, number) {
    var declare = lang.declare;
    var Base = Backbone.Collection;

    /**
     * Collections are ordered sets of models.
     *
     * This class extends Backbone.Collection with the following changes:
     * * model - change the default from Backbone.Model to uweaver/data/Model.
     * * url() - rewrite the url() to use the resource property to generate the URL of the model's resource on the server.
     * * fetch() &amp; sync() - rewrite to support pagination. see [fetch()]{@link Collection#fetch} for details.
     *
     * ##### Usage
     *     // Declare a new type of collection, Products, with the following designs:
     *     // * the resource - 'products'
     *     var declare = uweaver.lang.declare;
     *     var Products = declare(Collection, {
     *         resource: 'products'
     *     });
     *     var filters = [{"property":"price", "value":0.5, "operator":"GE"}, {"property":"price", "value":10, "operator":"LE"}];
     *     var sorters = [{"property":"price", "direction":"desc"}];
     *
     *     // fetch products from the server.
     *     products.on('update', function(collection) {
     *        ....
     *     });
     *     products.fetch({
     *         limit: 20,
     *         offset: 40,
     *         filters: filters,
     *         sorters: sorters,
     *         async: false
     *     });
     *
     *     // Create a product &amp; save it to the server.
     *     // Assign the product a business id - "sunflower".
     *     // The server will assign a object id for the product after saved.
     *     var products = new Products();
     *
     *     products.on('sync', function(model) {
     *        ....
     *     });
     *     products.create({
     *         id: "sunflower",
     *         name: "Sunflower",
     *         price: 0.5
     *     });
     *
     *     // Create a ad-hoc collection &amp; add an array of items.
     *     var collection = new Collection();
     *     var items = [{_id: "rose", name: "Rose"},{_id: "lily", name: "Lily"},{_id: "tomato", name: "Tomato"}];
     *
     *     collection.add(items);
     *     expect(collection.size()).to.equal(items.length);

     *
     * See [Backbone.Collection's document](http://backbonejs.org/#Collection) for details.
     *
     * ##### Events:
     * See [Backbone.Collection's events](http://backbonejs.org/#Events) for details.
     *
     * @constructor Collection
     * @extends Backbone.Collection
     * @author  Jason Lin
     * @since   1.0
     * @param {Object} [models] - the initial array of models.
     * @param {Object} [options] - A map of additional options to pass to the constructor.
     * See [Backbone.Collection's constructor](http://backbonejs.org/#Collection-constructor) for details.
     */
    function initialize(models, options) {
        Base.prototype.initialize.apply(this, arguments);

        options || (options = {});

        var defaults = {};

        _.defaults(options, defaults);

        this._limit = 0;
        this._offset = 0;
        this._filters = [];
        this._sorters = [];
        this._conjunction = "AND";

        options.model &amp;&amp; (this.model = options.model);
        options.proxy &amp;&amp; (this._proxy = options.proxy);
    }

    /**
     * Get or set the total property(the total number of records) returned from the server.
     *
     * @memberof Collection#
     * @returns {Integer}
     */
    function total(value) {
        if(arguments.length===0) return this._total;

        this._total = value;
    }

    /**
     * Get the limit property(page size) returned from the server.
     *
     * @memberof Collection#
     * @returns {Integer}
     */
    function limit() {
        return this._limit;
    }

    /**
     * Get the offset property returned from the server.
     *
     * @memberof Collection#
     * @returns {Integer}
     */
    function offset() {
        return this._offset;
    }

    /**
     * Get the filters(criteria) property returned from the server.
     *
     * @memberof Collection#
     * @returns {Object[]}
     */
    function filters() {
        return this._filters;
    }

    /**
     * Get the sorters(ordering) property returned from the server.
     *
     * @memberof Collection#
     * @returns {Object[]}
     */
    function sorters() {
        return this._sorters;
    }

    function conjunction() {
        return this._conjunction;
    }

    /**
     * Get the number of models in the collection.
     *
     * @memberof Collection#
     * @returns {Integer}
     */
    function size() {
        return this.length;
    }

    function proxy(theProxy) {
        if(!theProxy) return this._proxy;

        this._proxy = theProxy;
    }

    function reader(theReader) {
        if(!theReader) return this._reader;

        this._reader = theReader;
    }

    /**
     * Retrieve the data from the server.
     *
     * @memberof Collection#
     * @param {String} method - The method name.
     * @param {Collection} data - The collection to be read.
     * @param {Object} options - success and error callbacks, and all other jQuery request options.
     * See [Backbone.sync()](http://backbonejs.org/#Sync) for details.
     * @returns {Promise}
     */
    function sync(method, data, options) {
        var resource = this.resource;
        var action = method;

        // use the model's resource property when the collection's is not available
        //resource || (resource = (this.constructor.prototype.model &amp;&amp; this.constructor.prototype.model.prototype.resource));
        resource || (resource = (this.model &amp;&amp; this.model.prototype.resource));

        return this.proxy().sync(resource, action, data, options);
    }

    function request(subresource, options) {
        var resource = this.resource;

        // use the model's resource property when the collection's is not available
        //resource || (resource = (this.constructor.prototype.model &amp;&amp; this.constructor.prototype.model.prototype.resource));
        resource || (resource = (this.model &amp;&amp; this.model.prototype.resource));

        return this.proxy().request(resource, subresource, this, options);
    }

    /**
     * called whenever the collection's items are returned by the server, in fetch.
     * The function is passed the raw response object, and should return the array of model attributes to be added to the collection.
     *
     * @memberof Collection#
     * @param {Object} response - The raw response object.
     * @param {Object} options - optional arguments.
     * @returns {Array} the array of item attributes to be added to the collection.
     */
    function parse(response, options) {
        return this.reader().parse(this, response, options);
    }

    /**
     * Fetch the default set of models for this collection from the server, setting them on the collection when they arrive.
     *
     * @memberof Collection#
     * @param {Object} options - optional arguments.
     * ##### Options
     * + limit -  limit the number of results returned .
     * + offset - skip the first N rows before beginning to return results.
     * + filters - An array of objects to specify the criteria of the results. Examples: [{"property":"price", "value":0.5, "operator":"GE"}, {"property":"price", "value":10, "operator":"LE"}].
     * + sorters - An array of objects to specify the ordering of the results. Examples: [{"property":"price", "direction":"DESC"}]
     * + conjunction - A string specify the logical conjunction of the filters. Examples: "AND"
     * See [Backbone.Collection.fetch()](http://backbonejs.org/#Collection-fetch) for more options.
     * @returns {Collection} this
     */
    function fetch(options) {
        var resource = this.resource;
        resource || (resource = (this.model &amp;&amp; this.model.prototype.resource));

        options || (options = {});

        var defaults = {
            conjunction: "AND"
        };
        _.defaults(options, defaults);

        if(options.filters) {
            this._filters = options.filters;
            this._offset = 0;
        }
        options.sorters &amp;&amp; (this._sorters = options.sorters);
        (options.limit!==undefined) &amp;&amp; (this._limit = options.limit);
        (options.offset!==undefined) &amp;&amp; (this._offset = options.offset);
        this._conjunction = options.conjunction;

        this._offset = Math.max(0, this._offset);

        var promise = Base.prototype.fetch.call(this, _.omit(options, "success", "error"));

        promise.then(function(response, status, xhr) {
            _.isFunction(options.success) &amp;&amp; options.success.apply((options.context||this), arguments);
        }, function(xhr, status, error) {
            _.isFunction(options.error) &amp;&amp; options.error.apply((options.context||this), arguments);
        }, this);

        return promise;
    }

    function count(options) {
        options || (options = {});

        var resource = this.resource;
        resource || (resource = (this.model &amp;&amp; this.model.prototype.resource));

        if(!resource) return;

        var defaults = {
            conjunction: "AND"
        };

        _.defaults(options, defaults);

        var settings = {
            method: "GET",
            async: false,
            data: {}
        };

        options.filters &amp;&amp; (settings.data.filters = JSON.stringify(options.filters));

        _.defaults(settings, options);

        _.defaults(settings.data, options.data);

        var promise = this.sync("count", this, settings);

        var c = undefined;
        promise.then(function(response, status, xhr) {
            if(xhr.getResponseHeader('Item-Count')!==null) {
                c = number.parse(xhr.getResponseHeader('Item-Count'));
            }
        });
        
        return c;
    }

    function hasChanged() {
        if(this._hashCode==undefined) return false;
        if(_.keys(this._hashCode).length!==this.size()) return true;

        var result = false;
        for(var i=0; i&lt;this.size(); i++) {
            var model = this.at(i);
            if(hash(model)!==this._hashCode[model.cid]) {
                result = true;
                break;
            }
        }
        return result;
    }

    function hash(model) {
        var hashCode = 0;
        var json = JSON.stringify(model.toJSON());
        for (var i = 0; i &lt; json.length; i++) {
            var char = json.charCodeAt(i);
            hashCode = ((hashCode&lt;&lt;5)-hashCode)+char;
            hashCode = hashCode &amp; hashCode; // Convert to 32bit integer
        }
        return hashCode;
    }

    function baseline() {
        var hashCode = {};

        this.each(function(model) {
            hashCode[model.cid] = hash(model);
        });

        this._hashCode = hashCode;

    }
    
    var props = {
        model: Model,
        resource: undefined,

        _proxy: new REST(),
        _reader: new Json(),
        _total: undefined,
        _limit: undefined,
        _offset: undefined,
        _filters: undefined,
        _sorters: undefined,
        _conjunction: undefined,
        _hashCode: undefined
    };

    var Collection = declare(Base, {
        initialize: initialize,
        proxy: proxy,
        reader: reader,
        sync: sync,
        request: request,
        parse: parse,
        fetch: fetch,
        count: count,
        size: size,
        total: total,
        limit: limit,
        offset: offset,
        filters: filters,
        sorters: sorters,
        conjunction: conjunction,
        baseline: baseline,
        hasChanged: hasChanged
    }, props);

    Collection.PROXY = {
        REST: new REST()
    };

    Collection.READER = {
        JSON: new Json()
    };

    return Collection;

});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
